--[[

Scan for collectible items every 1-2 seconds.
Try to collect them if possible.

]]--

function fai_hl2d_itemsearch(id)
	local result_tab = {}
	local tab, px, py = Apple.GroundItems, player(id, "tilex"), player(id, "tiley")
	for k, m in ipairs(tab) do
		if Apple.Distance(px, py, m.x, m.y) < 6 then
			table.insert(result_tab, k)
		end
	end
	return result_tab
end
	

-- Collect Items
function fai_collect(id)
	
	-- Scan Timer
	vai_itemscan[id]=vai_itemscan[id]+1
	if vai_itemscan[id]>100 then
		vai_itemscan[id]=math.random(0,50)
		
		-- Not collecting yet AND not a zombie?
		if vai_mode[id]~=6 then
			-- Find and scan close items (5 tiles around)
			local items=fai_hl2d_itemsearch(id)
			for i=1,#items do
				-- Not on same tile?
				local ground_item = Apple.GroundItems[items[i]]
				local hl2d_item = Apple.Weapons[ground_item.type]
				local itemx, itemy, itype = ground_item.x, ground_item.y, ground_item.type
				if itemx~=player(id,"tilex") or itemy~=player(id,"tiley") then
					local collect=false
					if hl2d_item.speciality then
						if hl2d_item.speciality == "health" then
							if player(id,"health")<player(id,"maxhealth") then
								collect=true
							end
						end
					else
						if ground_item.ammo then
							local ammowpn = hl2d_item.wpn
							if Apple.Weapons[ammowpn].maxammo then
								if Apple.Ammo[id][ammowpn][2] < Apple.Weapons[ammowpn].maxammo then
									collect = true
								end
							else
								if Apple.Ammo[id][ammowpn][1] < Apple.Weapons[ammowpn].clip then
									collect = true
								end
							end
						else
							if Apple.Ammo[id][itype][2] <= (Apple.Weapons[itype].maxammo or -1) then
								collect = true
							end
						end
					end
					--Perform collect?
					if collect then
						vai_mode[id]=6
						vai_smode[id]=itype
						vai_destx[id]=itemx
						vai_desty[id]=itemy
						break
					end
					
				end
			end
		end
	end
end